unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  IMPLEMENTATION

USES ActiveX,
  ShlObj,
  registry,
  ComObj;
{$R *.dfm}

FUNCTION GetFolder(CONST SpecialFolderCSIDL: integer): STRING;
VAR malloc: IMalloc;
  pidl: PItemIDList;
BEGIN
  IF (SHGetMalloc(malloc) = NOERROR) AND
    (SHGetSpecialFolderLocation(INVALID_HANDLE_VALUE, SpecialFolderCSIDL, pidl) = NOERROR) THEN TRY
    SetLength(result, MAX_PATH + 1);
    IF SHGetPathFromIDList(pidl, pchar(result)) THEN
      result := pchar(result)
    ELSE
      result := '';
  FINALLY malloc.Free(pidl) END;
END;

PROCEDURE CreateShortcutIn(CONST SpecialFolderCSIDL: integer; CONST shortcutName: STRING);
VAR
  IObject: IUnknown;
  ISLink: IShellLink;
  IPFile: IPersistFile;
  PIDL: PItemIDList;
  InFolder: ARRAY[0..MAX_PATH] OF Char;
  TargetName: STRING;
  LinkName: WideString;
BEGIN
  CoInitialize(NIL);

  TargetName := ParamStr(0);

  IObject := CreateComObject(CLSID_ShellLink);
  ISLink := IObject AS IShellLink;
  IPFile := IObject AS IPersistFile;

  WITH ISLink DO BEGIN
    SetPath(pChar(TargetName));
    SetWorkingDirectory(pChar(ExtractFilePath(TargetName)));
  END;

  SHGetSpecialFolderLocation(0, SpecialFolderCSIDL, PIDL);
  SHGetPathFromIDList(PIDL, InFolder);

  LinkName := Format('%s\%s.lnk', [InFolder, shortcutName]);

  IPFile.Save(PWChar(LinkName), false);

  CoUnInitialize;
END;

FUNCTION GetFileList(FDirectory, Filter: TFileName): TStringList;
VAR
  ARec: TSearchRec;
BEGIN
  IF FDirectory[Length(FDirectory)] <> '\' THEN
    FDirectory := FDirectory + '\';

  Result := TStringList.Create;
  TRY
    IF FindFirst(FDirectory + Filter, faAnyFile, ARec) = 0 THEN BEGIN
      REPEAT
        IF FileExists(FDirectory + ARec.Name) THEN
          Result.Add(FDirectory + ARec.Name);

      UNTIL FindNext(ARec) <> 0;
    END;
    sysutils.FindClose(ARec);
  EXCEPT
    Result.Free;
  END;
END;

FUNCTION IsRegistered: Boolean;
VAR
  reg: TRegistry;
BEGIN
  reg := TRegistry.Create(KEY_READ OR KEY_WRITE);
  reg.RootKey := HKEY_CURRENT_USER;
  RESULT := reg.KeyExists('software\classes\*\shell\deleteit') AND
    reg.KeyExists('software\classes\directory\shell\deleteit');
  reg.CloseKey;
  reg.Free;
END;

PROCEDURE RegisterFileType;
VAR
  reg: TRegistry;
BEGIN
  reg := TRegistry.Create(KEY_READ OR KEY_WRITE);
  reg.RootKey := HKEY_CURRENT_USER;

  IF NOT reg.KeyExists('software\classes\*\shell\deleteit') THEN BEGIN
    IF reg.OpenKey('software\classes\*\shell\deleteit', TRUE) THEN BEGIN
      reg.WriteString('', 'Securely delete this file');
      reg.CloseKey;
    END;
    IF reg.OpenKey('software\classes\*\shell\deleteit\command', TRUE) THEN BEGIN
      reg.WriteString('', Paramstr(0) + ' "%1"');
      reg.CloseKey;
    END;
  END;

  IF NOT reg.KeyExists('software\classes\directory\shell\deletit') THEN BEGIN
    IF reg.OpenKey('software\classes\directory\shell\deleteit', TRUE) THEN BEGIN
      reg.WriteString('', 'Securely delete this folder');
      reg.CloseKey;
    END;
    IF reg.OpenKey('software\classes\directory\shell\deleteit\command', TRUE) THEN BEGIN
      reg.WriteString('', Paramstr(0) + ' "%1"');
      reg.CloseKey;
    END;
  END;
  reg.Free;
END;

PROCEDURE UnregisterFileType;
VAR
  reg: TRegistry;
BEGIN
  reg := TRegistry.Create;
  reg.RootKey := HKEY_CURRENT_USER;

  IF reg.KeyExists('software\classes\*\shell\deleteit') THEN BEGIN
    reg.DeleteKey('software\classes\*\shell\deleteit');
  END;

  IF reg.KeyExists('software\classes\directory\shell\deleteit') THEN BEGIN
    reg.DeleteKey('software\classes\directory\shell\deleteit');
  END;

  reg.Free;
END;


procedure TForm2.FormCreate(Sender: TObject);
begin
     CheckBox1.Checked := isRegistered;
    CheckBox2.Checked := FileExists(GetFolder(CSIDL_SENDTO) + '\Secure file deletion.lnk');
    CheckBox3.Checked := FileExists(GetFolder(CSIDL_DESKTOP) + '\Secure delete.lnk');

end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  IF NOT CheckBox1.Checked THEN
    UnRegisterFileType
  ELSE
    RegisterFileType;
  IF NOT CheckBox2.Checked THEN
    DeleteFile(pChar(GetFolder(CSIDL_SENDTO) + '\Secure file deletion.lnk'))
  ELSE
    CreateShortcutIn(CSIDL_SENDTO, 'Secure file deletion');

  IF NOT CheckBox3.Checked THEN
    DeleteFile(pChar(GetFolder(CSIDL_DESKTOP) + '\Secure delete.lnk'))
  ELSE
    CreateShortcutIn(CSIDL_DESKTOP, 'Secure delete');

    Application.Terminate;
end;

end.
