unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

  CONST
  ToDo = 'You are about to wipe files and MAKE THEN UNREVOVERABLE! Continue?';
  Doing = 'Securely deleting files - press STOP to abort deletion process';

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
   protected
    PROCEDURE CreateParams(VAR Params: TCreateParams); override;
  public
    { Public declarations }
    PROCEDURE doDeleteFolder(Folder: TFilename);
    PROCEDURE doDeleteFile(fname: TFilename);

  END;

var
  Form1: TForm1;
  Running: Boolean = FALSE;

implementation

{$R *.dfm}

FUNCTION GetFileList(FDirectory, Filter: TFileName): TStringList;
VAR
  ARec: TSearchRec;
BEGIN
  IF FDirectory[Length(FDirectory)] <> '\' THEN
    FDirectory := FDirectory + '\';

  Result := TStringList.Create;
  TRY
    IF FindFirst(FDirectory + Filter, faAnyFile, ARec) = 0 THEN BEGIN
      REPEAT
        IF FileExists(FDirectory + ARec.Name) THEN
          Result.Add(FDirectory + ARec.Name);

      UNTIL FindNext(ARec) <> 0;
    END;
    sysutils.FindClose(ARec);
  EXCEPT
    Result.Free;
  END;
END;

FUNCTION IsDirectoryEmpty(CONST directory: STRING): boolean;
VAR
  searchRec: TSearchRec;
BEGIN
  TRY
    result := (FindFirst(directory + '\*.*', faAnyFile, searchRec) = 0) AND
      (FindNext(searchRec) = 0) AND
      (FindNext(searchRec) <> 0);
  FINALLY
    sysutils.FindClose(searchRec);
  END;
END;

PROCEDURE WipeFile(fInFile: STRING);
VAR
  buffer: ARRAY[0..4095] OF byte;
  max, n: LongInt;
  i, j: Integer;
  fs: tFilestream;

  PROCEDURE SetZero;
  BEGIN
    fillchar(buffer, length(buffer), $00);
  END;

  PROCEDURE SetLots;
  BEGIN
    fillchar(buffer, Length(buffer), $FF);
  END;

  PROCEDURE RandomizeBuffer;
  VAR
    i: Integer;
  BEGIN
    randomize;
    FOR i := Low(buffer) TO High(buffer) DO
      buffer[i] := Random(256);
  END;

  FUNCTION ReName(Filename: STRING): STRING;
  BEGIN
    randomize;
    RESULT := ExtractFilePath(Filename) + Format('$TMP%d.tmp', [Random(5000)]);
    IF NOT RenameFile(Filename, RESULT) THEN
      RAISE
        Exception.CreateFmt('Cannot find %s !', [FileName]);
  END;

BEGIN

  TRY

    fInFile := ReName(FInfile);

    fs := tFileStream.Create(finfile, fmOpenWrite OR fmShareDenyNone);

    FOR i := 1 TO 7 DO BEGIN
      CASE i OF
        1, 3, 5: setzero;
        2, 4, 6: setlots;
        7: RandomizeBuffer;
      END;

      max := fs.Size;
      fs.Position := 0;

      WHILE max > 0 DO BEGIN
        IF max > Sizeof(buffer) THEN
          n := sizeof(buffer)
        ELSE
          n := max;
        fs.Write(Buffer, n);
        max := max - n;
      END;

      IF NOT FlushFileBuffers(fs.handle) THEN
        RAISE
          Exception.Create('Buffer flushing failed!');
    END;
  FINALLY
    fs.free;
  END;

  fInFile := ReName(FInfile);

  IF NOT Deletefile(pchar(fInfile)) THEN
    RAISE
      Exception.Create('Deletion failed!');

END;

PROCEDURE tForm1.doDeleteFolder(Folder: TFilename);
VAR
  st: tStringList;
  i: integer;

BEGIN

  st := getfilelist(Folder, '*.*');

  Progressbar1.Max:=st.Count;

  TRY
    FOR i := 0 TO st.Count - 1 DO BEGIN
    doDeleteFile(st[i]);
    //  application.ProcessMessages;
    //  IF Running THEN
      //  WipeFile(st[i]);
    END;
  FINALLY
    st.Free;
  END;

  IF isdirectoryempty(paramstr(1)) THEN
    removedir(paramstr(1));
END;

PROCEDURE tForm1.doDeleteFile(fname: TFilename);
BEGIN
  IF Running THEN BEGIN
  SetFileAttributes(PChar(fName), FILE_ATTRIBUTE_NORMAL);
  Progressbar1.StepBy(1);
  application.ProcessMessages;
  WipeFile(fName);
  END;
END;

PROCEDURE TForm1.Button2Click(Sender: TObject);
BEGIN
  Running := FALSE;
  Application.ProcessMessages;
  Application.Terminate;
END;

PROCEDURE TForm1.Button1Click(Sender: TObject);
VAR
  J: INTEGER;
BEGIN

  Running := TRUE;

  Progressbar1.Position:=0;

  Label1.Caption := Doing;

  application.processmessages;

  FOR J := 1 TO ParamCount DO BEGIN
    IF DirectoryExists(paramstr(J)) THEN
      doDeleteFolder(Paramstr(J))
    ELSE
      doDeleteFile(Paramstr(J));
  END;

  Application.Terminate;

END;

PROCEDURE TForm1.CreateParams(VAR Params: TCreateParams);
BEGIN
  INHERITED CreateParams(Params);
  WITH Params DO BEGIN
    Style := (Style OR WS_POPUP) AND (NOT WS_DLGFRAME);
  END;
END;

PROCEDURE TForm1.FormCreate(Sender: TObject);
BEGIN
  Label1.Caption := ToDo;
END;








end.
